;--------------------------------------------------------------------------------
; Games for Windows LIVE Demo - Tools.au3
;--------------------------------------------------------------------------------
Global Const $AC_SRC_ALPHA = 1


Func _GUICreate_Alpha($sTitle, $sPath, $iX=-1, $iY=-1, $iOpacity=255)
    Local $hGUI, $hImage, $hScrDC, $hMemDC, $hBitmap, $hOld, $pSize, $tSize, $pSource, $tSource, $pBlend, $tBlend
    $hImage = _GDIPlus_ImageLoadFromFile($sPath)
    $width = _GDIPlus_ImageGetWidth($hImage)
    $height = _GDIPlus_ImageGetHeight($hImage)
    $hGUI = GUICreate($sTitle, $width, $height, $iX, $iY, $WS_POPUP, $WS_EX_LAYERED)
    $hScrDC = _WinAPI_GetDC(0)
    $hMemDC = _WinAPI_CreateCompatibleDC($hScrDC)
    $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
    $hOld = _WinAPI_SelectObject($hMemDC, $hBitmap)
    $tSize = DllStructCreate($tagSIZE)
    $pSize = DllStructGetPtr($tSize)
    DllStructSetData($tSize, "X", $width)
    DllStructSetData($tSize, "Y", $height)
    $tSource = DllStructCreate($tagPOINT)
    $pSource = DllStructGetPtr($tSource)
    $tBlend = DllStructCreate($tagBLENDFUNCTION)
    $pBlend = DllStructGetPtr($tBlend)
    DllStructSetData($tBlend, "Alpha", $iOpacity)
    DllStructSetData($tBlend, "Format", 1)
    _WinAPI_UpdateLayeredWindow($hGUI, $hScrDC, 0, $pSize, $hMemDC, $pSource, 0, $pBlend, 2)
    _WinAPI_ReleaseDC(0, $hScrDC)
    _WinAPI_SelectObject($hMemDC, $hOld)
    _WinAPI_DeleteObject($hBitmap)
    _WinAPI_DeleteObject($hImage)
    _WinAPI_DeleteDC($hMemDC)
EndFunc ;==>_GUICreate_Alpha

Func SetBitmap($hGUI, $hImage, $iOpacity)
    Local $hScrDC, $hMemDC, $hBitmap, $hOld, $pSize, $tSize, $pSource, $tSource, $pBlend, $tBlend
    
    $hScrDC = _WinAPI_GetDC(0)
    $hMemDC = _WinAPI_CreateCompatibleDC($hScrDC)
    $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
    $hOld = _WinAPI_SelectObject($hMemDC, $hBitmap)
    $tSize = DllStructCreate($tagSIZE)
    $pSize = DllStructGetPtr($tSize)
    DllStructSetData($tSize, "X", _GDIPlus_ImageGetWidth($hImage))
    DllStructSetData($tSize, "Y", _GDIPlus_ImageGetHeight($hImage))
    $tSource = DllStructCreate($tagPOINT)
    $pSource = DllStructGetPtr($tSource)
    $tBlend = DllStructCreate($tagBLENDFUNCTION)
    $pBlend = DllStructGetPtr($tBlend)
    $tPoint = DllStructCreate($tagPOINT) ; Create point destination structure here
    $pPoint = DllStructGetPtr($tPoint) ; Create pointer to this dll data structure, $pPTDest parameter
    DllStructSetData($tBlend, "Alpha", $iOpacity)
    DllStructSetData($tBlend, "Format", $AC_SRC_ALPHA)
    _WinAPI_UpdateLayeredWindow($hGUI, $hScrDC, 0, $pSize, $hMemDC, $pSource, 0, $pBlend, $ULW_ALPHA)
    _WinAPI_ReleaseDC(0, $hScrDC)
    _WinAPI_SelectObject($hMemDC, $hOld)
    _WinAPI_DeleteObject($hBitmap)
    _WinAPI_DeleteDC($hMemDC)
EndFunc   ;==>SetBitmap

;===============================================================================
;
; Function Name:   _API_SetLayeredWindowAttributes
; Description::    Sets Layered Window Attributes:) See MSDN for more informaion
; Parameter(s):
;                  $hwnd - Handle of GUI to work on
;                  $i_transcolor - Transparent color
;                  $Transparency - Set Transparancy of GUI
;                  $isColorRef - If True, $i_transcolor is a COLORREF-Strucure, else an RGB-Color
; Requirement(s):  Layered Windows
; Return Value(s): Success: 1
;                  Error: 0
;                   @error: 1 to 3 - Error from DllCall
;                   @error: 4 - Function did not succeed - use
;                               _WinAPI_GetLastErrorMessage or _WinAPI_GetLastError to get more information
; Author(s):       Prog@ndy
;
;===============================================================================
;
Func _API_SetLayeredWindowAttributes($hwnd, $i_transcolor, $Transparency = 255, $isColorRef = False)

    Local Const $AC_SRC_ALPHA = 1
    Local Const $ULW_ALPHA = 2
    Local Const $LWA_ALPHA = 0x2
    Local Const $LWA_COLORKEY = 0x1
    If Not $isColorRef Then
        $i_transcolor = Hex(String($i_transcolor), 6)
        $i_transcolor = Execute('0x00' & StringMid($i_transcolor, 5, 2) & StringMid($i_transcolor, 3, 2) & StringMid($i_transcolor, 1, 2))
    EndIf
    Local $Ret = DllCall("user32.dll", "int", "SetLayeredWindowAttributes", "hwnd", $hwnd, "long", $i_transcolor, "byte", $Transparency, "long", $LWA_COLORKEY + $LWA_ALPHA)
    Select
        Case @error
            Return SetError(@error, 0, 0)
        Case $Ret[0] = 0
            Return SetError(4, 0, 0)
        Case Else
            Return 1
    EndSelect
EndFunc  ;==>_API_SetLayeredWindowAttributes

Func _ImageDrawText($hImage, $sText, $iX = 0, $iY = 0, $iRGB = 0x000000, $iSize = 9, $iStyle = 0, $sFont = "Arial") 
    Local $w, $h, $hGraphic1, $hBitmap, $hGraphic2, $hBrush, $hFormat, $hFamily, $hFont, $tLayout, $aInfo
    $w = _GDIPlus_ImageGetWidth($hImage)
    $h = _GDIPlus_ImageGetHeight($hImage)
    
    ;Create a new bitmap, this way the original opened png is left unchanged
    $hGraphic1 = _GDIPlus_GraphicsCreateFromHWND(_WinAPI_GetDesktopWindow())
    $hBitmap = _GDIPlus_BitmapCreateFromGraphics($w, $h, $hGraphic1)
    $hGraphic2 = _GDIPlus_ImageGetGraphicsContext($hBitmap) 
    
    ; Draw the original opened png into my newly created bitmap
    _GDIPlus_GraphicsDrawImageRect($hGraphic2, $hImage, 0, 0, $w, $h)

    ;Create the font
    $hBrush = _GDIPlus_BrushCreateSolid ("0xFF" & Hex($iRGB, 6))
    $hFormat = _GDIPlus_StringFormatCreate()
    $hFamily = _GDIPlus_FontFamilyCreate ($sFont)
    $hFont = _GDIPlus_FontCreate ($hFamily, $iSize, $iStyle)
    $tLayout = _GDIPlus_RectFCreate ($iX, $iY, 0, 0)
    $aInfo = _GDIPlus_GraphicsMeasureString ($hGraphic2, $sText, $hFont, $tLayout, $hFormat)
    
    ;Draw the font onto the new bitmap
    _GDIPlus_GraphicsDrawStringEx ($hGraphic2, $sText, $hFont, $aInfo[0], $hFormat, $hBrush)
    
    ;Cleanup the no longer needed resources
    _GDIPlus_FontDispose ($hFont)
    _GDIPlus_FontFamilyDispose ($hFamily)
    _GDIPlus_StringFormatDispose ($hFormat)
    _GDIPlus_BrushDispose ($hBrush)
    _GDIPlus_GraphicsDispose ($hGraphic2)
    _GDIPlus_GraphicsDispose ($hGraphic1)

    ;Return the new bitmap
    Return $hBitmap
EndFunc 

Func _ImageResize($newW, $newH,$IMG)
    Local $GC, $newBmp, $newGC

   ;Create New image
    $GC = _GDIPlus_ImageGetGraphicsContext($IMG)
    $newBmp = _GDIPlus_BitmapCreateFromGraphics($newW, $newH, $GC)
    $newGC = _GDIPlus_ImageGetGraphicsContext($newBmp)
   ;Draw
    _GDIPlus_GraphicsDrawImageRect($newGC, $IMG,0,0, $newW, $newH)
   ;Cleanup
   ;_GDIPlus_BitmapDispose($newBmp)
    _GDIPlus_GraphicsDispose($GC)
    _GDIPlus_GraphicsDispose($newGC)
    
    Return $newBmp
EndFunc  ;==>_ImageResize

func Beenden()
	SoundPlay($Klick_Sound,1)
Exit
EndFunc

func Abbrechen()
	SoundPlay($Klick_Sound,1)
	msgbox(64,"Info","Abbrechen gedrckt!")
EndFunc


func _Hauptfenster_EIN_AUS_Blenden()
	SoundPlay($Klick_Sound,1)
if $MAIN_WINDOWS_VISIBLE = 0 then 
_Show_Windowframe_FX($CURRENT_GUI_HANDLE)
Else
_HIDE_Windowframe_FX($CURRENT_GUI_HANDLE)
endif
EndFunc


	
func Weiter()
	SoundPlay($Klick_Sound,1)
	if $CURRENT_GUI_HANDLE = $TestGUI1 Then
		SoundPlay($Switch_Sound,0)
		_Fade_GUI($TestGUI1,$TestGUI2)
		return
	EndIf
	
	if $CURRENT_GUI_HANDLE = $TestGUI2 Then
		SoundPlay($Switch_Sound,0)
		_Fade_GUI($TestGUI2,$TestGUI1)
		return
	EndIf
	
EndFunc


;-------------------------------------
; Mouse Over GUI 
;-------------------------------------
func Hover_GUI($GUI,$MustBeVisible)

if NOT (WinActive($GUI) OR WinActive("Program Manager")  OR WinActive("MAINBAR") OR WinActive("GUITEST1") OR WinActive("GUITEST2") OR WinActive("MAIN_WINDOW") OR WinActive("Close_MAIN"))  then return

if $MustBeVisible = "main" then 
	if $MAIN_WINDOWS_VISIBLE = 0 then return
endif

Local $size_UP = WinGetPos($GUI)
Local $HIT_OBEN = 0
if ($pos[0] > $size_UP[0]) AND ($pos[1] > $size_UP[1]) AND  ($pos[0] < ($size_UP[0]+$size_UP[2])) AND ($pos[1] < ($size_UP[1]+$size_UP[3])) then 
		if $HIT_OBEN = 0 then 	GUISetState(@SW_SHOW,$GUI)
			$HIT_OBEN = 1	
	Else
		GUISetState(@SW_HIDE,$GUI)		
		$HIT_OBEN = 0
	EndIf

endfunc


func _Show_Windowframe_FX($GUI)
$MAIN_WINDOWS_VISIBLE = 1
$hImage1=_ImageResize(938,1,$MainWindow_PNG)
SetBitMap($MAIN_WINDOW_GUI, $hImage1, 255)
GUISetState(@SW_SHOW,$MAIN_WINDOW_GUI)	
SoundPlay($Show_Sound,0)	
$y = 1
$alpha = 0
while 1
if $alpha < 255 then $alpha = $alpha+15
$y = $y+40
$hImage1=_ImageResize(938,$y,$MainWindow_PNG)
SetBitMap($MAIN_WINDOW_GUI, $hImage1, $alpha)
if $y > 505 then 
	$hImage1=_ImageResize(938,505,$MainWindow_PNG)
	SetBitMap($MAIN_WINDOW_GUI, $hImage1, 255)
	exitloop
	EndIf
WEnd
GUISetState(@SW_SHOW,$Window_Button1)
GUISetState(@SW_SHOW,$Window_Button2)
GUISetState(@SW_SHOW,$GUI)
$CURRENT_GUI_HANDLE = $GUI
SetBitMap($MAIN_BAR_UP_DOWN_BUTTON,_GDIPlus_ImageLoadFromFile(@ScriptDir & "\img\Bar_UP1.png"), 255)	
SetBitMap($MAIN_BAR_UP_DOWN_BUTTON_Over,_GDIPlus_ImageLoadFromFile(@ScriptDir & "\Img\Bar_UP2.png"), 255)
EndFunc

func _HIDE_Windowframe_FX($GUI)
$MAIN_WINDOWS_VISIBLE = 0
GUISetState(@SW_HIDE,$Window_Button1)
GUISetState(@SW_HIDE,$Window_Button1_Over)
GUISetState(@SW_HIDE,$Window_Button2)
GUISetState(@SW_HIDE,$Window_Button2_Over)
GUISetState(@SW_HIDE,$GUI)
$hImage1=_ImageResize(938,505,$MainWindow_PNG)
SetBitMap($MAIN_WINDOW_GUI, $hImage1, 255)
SoundPlay($HIDE_Sound,0)	
$y = 505
$alpha = 255
while 1
$y = $y-40
if $alpha > 1 then $alpha = $alpha-15
$hImage1=_ImageResize(938,$y,$MainWindow_PNG)
SetBitMap($MAIN_WINDOW_GUI, $hImage1, $alpha)
if $y < 1 then 
	$hImage1=_ImageResize(938,1,$MainWindow_PNG)
	SetBitMap($MAIN_WINDOW_GUI, $hImage1, 255)
	exitloop
	EndIf
WEnd
SetBitMap($MAIN_BAR_UP_DOWN_BUTTON,_GDIPlus_ImageLoadFromFile(@ScriptDir & "\img\Bar_Down1.png"), 255)
SetBitMap($MAIN_BAR_UP_DOWN_BUTTON_Over,_GDIPlus_ImageLoadFromFile(@ScriptDir & "\Img\Bar_Down2.png"), 255)
GUISetState(@SW_HIDE,$MAIN_WINDOW_GUI)	
EndFunc

Func _Fade_GUI($GUI1,$GUI2)
GUISetState(@SW_SHOW,$GUI2)	
GUISetState(@SW_HIDE,$GUI1)
$CURRENT_GUI_HANDLE = $GUI2
EndFunc
